{*------------------------------------------------------------------------------
 Unit de gestion de la skin de la fentre

 @Author    Source tir du site : http://www.phidels.com
-------------------------------------------------------------------------------}
unit UGestionSkin;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms;


procedure SkinFenetre(ImageBmp:Tbitmap);


implementation


{*------------------------------------------------------------------------------
  Procedure pour skiner une fentre  partir d'une image Bitmap

  @param    ImageBmp : Image de la skin
-------------------------------------------------------------------------------}
procedure SkinFenetre(ImageBmp:Tbitmap);
var
  x,y,reg,regtemp,debut,fin: integer;
  etaitblanc,first: boolean;
begin
  Application.MainForm.height := ImageBmp.height;   //on adapte les
  Application.MainForm.width  := ImageBmp.width;    //dimensions de la fiche
  first:=true;
  Reg:=0;
  for y:=1 to ImageBmp.height do
  begin
    debut:=1;
    etaitblanc:=true;
    for x:=1 to ImageBmp.width do
    begin
      if ImageBmp.Canvas.Pixels[x,y]=ImageBmp.Canvas.Pixels[0,0] then //Vrifie si le pixel est de la couleur transparente
      begin
        if etaitblanc=false then  //et que le prcdent ne l'etait pas
        begin
          fin:=x-1;   //le dernier pixel non transparent etait le precedent
          if first=true then //si c'est la 1region qu'on cre:
          begin
            reg:=CreateRectRgn(debut,y,fin+1,y+1); //on la cre
            first:=false;  //la prochaine ne sera plus la premiere
          end
          else
          begin//si c'est pas la premiere region
            regtemp:=createrectrgn(debut,y,fin+1,y+1);//on en cre une temporaire
            CombineRgn(reg, reg, regtemp, rgn_or);//on l'ajoute  reg qui sera la region finale avec rgn_or (voir autres possibilits dans l'aide)
            deleteobject(regtemp);//on supprime la region temporaire pour rester propres (si on ne le fait pas, ca se fait autom. qd on ferme l'application)
          end;
        end;
        etaitblanc:=true;
      end
      else      //le pixel n'est pas transparent
      begin
        if etaitblanc=true then debut:=x;//ben oui rien que ca
        etaitblanc:=false;
        if x=ImageBmp.width-1 then //on arrive au dernier point de la ligne
          if first=true then //si c'est la 1region qu'on cre:
          begin
            reg:=CreateRectRgn(debut,y,x,y+1); //on la cre
            first:=false;  //la prochaine ne sera plus la premiere
          end
          else
          begin//si c'est pas la premiere region
            regtemp:=createrectrgn(debut,y,x,y+1);//on en cre une temporaire
            CombineRgn(reg, reg, regtemp, rgn_or);//on l'ajoute  reg qui sera la region finale avec rgn_or (voir autres possibilits dans l'aide)
            deleteobject(regtemp);//on supprime la region temporaire pour rester propres (si on ne le fait pas, ca se fait autom. qd on ferme l'application)
          end;
      end;
    end;
  end;
  SetWindowRgn(Application.MainForm.handle, reg,true);//on applique la region
  application.ProcessMessages;//on le laisse un peu souffler (pas obligatoire, c'est juste par compassion pour le processeur)
end;

end.
